/**
  ******************************************************************************
  * @file    vkl060.c
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   This file contains all the vkl060 functions. 
	*          ļ VKl060
  ******************************************************************************
  * @attention
  ******************************************************************************
  */	
/* Includes ------------------------------------------------------------------*/
#include "vkl060.h"
  
/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define VKl060_CLK 10 //SCLźƵ,delay_nusʵ 50->10kHz 10->50kHz 5->100kHz
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//segtab[]ӦʵʵоƬLCDߣ߼-VKl060ο·
unsigned char vkl060_segtab[Vkl060_SEGNUM]={
	11,12,13,14,15,16,17,18,19,		//SEG11-SEG19
	20,21,22,23,24,25,				//SEG20-SEG25
};
//LCDʵֻSEG11SEG22ʹ
//.hļVKl060_SEGNUM=12
//const unsigned char vkl060_segtab[VKl060_SEGNUM]={	
//	11,12,13,14,15,16,17,18,19,	//SEG11-SEG19
//	20,21,22										//SEG20-SEG22
//};
//vkl060_dispramӦоƬʾRAM
unsigned char vkl060_dispram[Vkl060_SEGNUM/2];//ÿֽݶӦ2SEG
//Ӧvkl060_segtab[VKl060_SEGNUM]
//ʾRAM bufferΪ8λӦ2SEGbit7/bit3->com3,bit6/bit2->com2,bit5/bit1->com1,bit4/bit0->com0
//LCD ʵ  38
//1ǰλ2ʮλ3Ǹλ
/*ʾbufferlcdͼӳϵ
vkl060_dispram[VKl060_SEGNUM/2]=
{//com3   com2   com1     com0 //ӦоƬSEG  ӦʾRAM
	1D,     1E,    1F,      1A,     //seg11   		vkl060_dispram[0]-bit3-bit0
	  ,     1C,    1G,      1B,     //seg12				vkl060_dispram[0]-bit7-bit4
	2D,     2E,    2F,      2A,     //seg13				vkl060_dispram[1]-bit3-bit0
	  ,     2C,    2G,      2B,     //seg14				vkl060_dispram[1]-bit7-bit4
	3D,     3E,    3F,      3A,		  //seg15				vkl060_dispram[2]-bit3-bit0
	  ,     3C,    3G,      3B,			//seg16				vkl060_dispram[2]-bit7-bit4
}
*/
/*8ֵ 
     A
   F   B
     G
	 E   C
	   D
*/
unsigned char shuzi_zimo[15]= //ַֺģ
{
//0    1    2    3    4    5    6    7    8    9    -    L    o    H    i 
	0x5F,0x50,0x3D,0x79,0x72,0x6B,0x6F,0x51,0x7F,0x7B,0x20,0x0E,0x6C,0x76,0x50
};
unsigned char vkl060_segi,vkl060_comi;
unsigned char vkl060_maxcom;//com4com
/* Private function prototypes -----------------------------------------------*/
unsigned char Vkl060_InitSequence(void);
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nms(unsigned long int n)
{
	while(n--)
	{
		delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : I2CStart
* Description    : ʱ߸ʱɸߵ͵䣬ʾI2Cʼź
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl060_I2CStart( void )
{
  Vkl060_SCL_H();
  Vkl060_SDA_H();
  delay_nus(VKl060_CLK);
  Vkl060_SDA_L();
  delay_nus(VKl060_CLK);
}
/*******************************************************************************
* Function Name  : I2CStop
* Description    : ʱ߸ʱɵ͵ߵ䣬ʾI2Cֹͣź
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl060_I2CStop( void )
{
  Vkl060_SCL_H();
  Vkl060_SDA_L();
  delay_nus(VKl060_CLK);
  Vkl060_SDA_H();
  delay_nus(VKl060_CLK);
}
/*******************************************************************************
* Function Name  : I2CSlaveAck
* Description    : I2Cӻ豸Ӧѯ
* Input          : None
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Vkl060_I2CSlaveAck( void )
{
  unsigned int TimeOut;
  unsigned char RetValue;
	
  Vkl060_SCL_L();
	//ƬSDAΪIOҪΪ
	Vkl060_SET_SDA_IN();
  delay_nus(VKl060_CLK);
  Vkl060_SCL_H();//9sclk

  TimeOut = 10000;
  while( TimeOut-- > 0 )
  {
    if( Vkl060_GET_SDA()!=0 )//ȡack
    {
      RetValue = 1;
    }
    else
    {
      RetValue = 0;
      break;
    }
  } 
	Vkl060_SCL_L();
	//ƬSDAΪIOҪΪ
	Vkl060_SET_SDA_OUT(); 
  
  return RetValue;
}
/*******************************************************************************
* Function Name  : I2CCmdByte
* Description    : I2Cдһֽ,͸λ
* Input          : byte-Ҫд
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl060_I2CCmdByte( unsigned char byte )
{
	unsigned char i=8;
	while (i--)
	{ 
		Vkl060_SCL_L();
		if(byte&0x80)
			Vkl060_SDA_H();
		else
			Vkl060_SDA_L();
		byte<<=1; 
		delay_nus(VKl060_CLK);
		Vkl060_SCL_H();     
		delay_nus(VKl060_CLK);
	}
}
/*******************************************************************************
* Function Name  : I2CDatByte
* Description    : I2Cдһֽ,͵λ
* Input          : byte-Ҫд
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl060_I2CDatByte( unsigned char byte )
{
	unsigned char i=8;
	while (i--)
	{ 
		Vkl060_SCL_L();
		if(byte&0x01)
			Vkl060_SDA_H();
		else
			Vkl060_SDA_L();
		byte>>=1; 
		delay_nus(VKl060_CLK);
		Vkl060_SCL_H();     
		delay_nus(VKl060_CLK);
	}
}
/*******************************************************************************
* Function Name  : Write1Data
* Description    : д1ֽݵʾRAM
* Input          : Addr-дramĵַ
*                : Dat->дram
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Write1DataVkl060(unsigned char Addr,unsigned char Dat)
{
	//START ź
	Vkl060_I2CStart(); 
	//SLAVEַ
	Vkl060_I2CCmdByte(Vkl060_ADDR); 
	if( 1 == Vkl060_I2CSlaveAck() )
	{		
		Vkl060_I2CStop();
		return 1; 
	}
	//ʾRAMַ
	if(Addr>0x1f)
		Vkl060_I2CCmdByte(Vkl060_ADDR5_1); 
	else
		Vkl060_I2CCmdByte(Vkl060_ADDR5_0); 
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();
		return 1;
	}
	Vkl060_I2CCmdByte(Addr&0x1f); 
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();
		return 1;
	}
	//ʾݣ1ֽݰ2SEG
	Vkl060_I2CDatByte(Dat);
	if( Vkl060_I2CSlaveAck()==1 )
	{
		Vkl060_I2CStop();
		return 1;
	}
	//STOPź
 Vkl060_I2CStop();
 return 0;   
}
/*******************************************************************************
* Function Name  : WritenData
* Description    : дݵʾRAM
* Input          : Addr-дramʼַ
*                : Databuf->дrambufferָ
*                : Cnt->дramݸ
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char  WritenDataVkl060(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char n;
	
	//STARTź	
	Vkl060_I2CStart(); 									
	//SLAVEַ
	Vkl060_I2CCmdByte(Vkl060_ADDR); 	
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();													
		return 0;										
	}
	//ʾRAMʼַ
	if(Addr>0x1f)
		Vkl060_I2CCmdByte(Vkl060_ADDR5_1); 
	else
		Vkl060_I2CCmdByte(Vkl060_ADDR5_0); 
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();													
		return 0; 
	}
	Vkl060_I2CCmdByte(Addr&0x1f); 						
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();													
		return 0;
	}
	//CntݵʾRAM
	for(n=0;n<Cnt;n++)
	{ 
		Vkl060_I2CDatByte(*Databuf++);
		if( Vkl060_I2CSlaveAck()==1 )
		{
			Vkl060_I2CStop();													
			return 0;
		}
	}
	//STOPź
	 Vkl060_I2CStop();											
	 return 0;    
}
/*******************************************************************************
* Function Name  : Vkl060_DisAll
* Description    : SEGʾͬһݣbit7/bit3-COM3 bit6/bit2-COM2 bit5/bit1-COM1 bit4/bit0-COM0
* 					     : 磺0xffȫ 0x00ȫ 0x55 0xaa 0x33 
* Input          dat->дram(1ֽݶӦ2SEG)  
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl060_DisAll(unsigned char dat)
{
	unsigned char segi;
	unsigned char dispram[8];
	
	for(segi=0;segi<8;segi++)//SEGΪҪ1ֽڻ
	{
		dispram[segi]=dat;
	}
	dispram[7]&=0x0f; //İֽڻ0
	WritenDataVkl060(11,dispram,8);//8bitݶӦ2SEGÿ4bitݵַ1ÿ8λ1ACK
}
/*******************************************************************************
* Function Name  : DisSegComOn
* Description    : 1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl060_DisSegComOn(unsigned char seg,unsigned char com)
{
		Write1DataVkl060(seg,(1<<(com)));//8λݵ4bitЧÿ4bitݵַ1ÿ8λ1ACK
}
/*******************************************************************************
* Function Name  : DisSegComOff
* Description    : ر1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl060_DisSegComOff(unsigned char seg,unsigned char com)
{
		Write1DataVkl060(seg,~(1<<com));//8λݵ4bitЧÿ4bitݵַ1ÿ8λ1ACK
}
/*******************************************************************************
* Function Name  : Enter_Standby
* Description    : ͹ģʽ,ʾ
* Input          None 
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Vkl060_Enter_Standby(void)
{			
	Vkl060_I2CStart();
	Vkl060_I2CCmdByte(Vkl060_ADDR); 
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();
		return 1; 
	}
	Vkl060_I2CCmdByte(Vkl060_MODESET_1_3_OFF);		//ʾ 1/3bias
//		Vkl060_I2CCmdByte(Vkl060_MODESET_1_2_OFF);	//ʾ 1/2bias
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();
		return 1; 
	}
	Vkl060_I2CStop();
  return 0; 
}
/*******************************************************************************
* Function Name  : Exit_Standby
* Description    : ˳͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
unsigned char Vkl060_Exit_Standby(void)
{	
	unsigned char errorflag; //־λ1Ϊ0Ϊȷ
	
	//˳͹״̬vkl060	
	errorflag=Vkl060_InitSequence();
	
  return(errorflag);
}

/*******************************************************************************
* Function Name  : InitSequence
* Description    : ʼʱ
* Input          None 
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Vkl060_InitSequence(void)
{		
	unsigned char n;
	
	vkl060_maxcom=4;
  //ϵʼʱ	
	//ϵ100uSڳʼ
  delay_nus(100);
	//STOPź
	Vkl060_I2CStop();
	//STARTź
	Vkl060_I2CStart();
	//SLAVEַ
	Vkl060_I2CCmdByte(Vkl060_ADDR); 
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();	
		return 1;
	}
	//λ
	Vkl060_I2CCmdByte(Vkl060_SOFTRST);
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();	
		return 1;
	}
	//ͬĹģʽһcomҲһ
//	Vkl060_I2CCmdByte(Vkl060_DISCTL|Vkl060_FRNOR|Vkl060_SRNOR|Vkl060_LINER );  //ϵĬ VDD=5V:<29uA  VDD=3.3V:<21uA 
	Vkl060_I2CCmdByte(Vkl060_DISCTL|Vkl060_FRPM3|Vkl060_SRPM1|Vkl060_FRAMER);  //ʡ VDD=5V:<12.7uA  VDD=3.3V:<8.5uA 
//	Vkl060_I2CCmdByte(Vkl060_DISCTL|Vkl060_FRPM1|Vkl060_SRPM1|Vkl060_FRAMER);  // VDD=5V:<13uA  VDD=3.3V:<9uA 
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();	
		return 1;
	}
	//ӳʼַ bit5=0
	Vkl060_I2CCmdByte(Vkl060_ADDR5_0); //SEG32-SEG63ַ	
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();	
		return 1;
	} 
	//ӳʼַ bit4~bit0=0
	Vkl060_I2CCmdByte(Vkl060_ADSET);//SEG0-SEG31ַ
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();	
		return 1;
	}
	//ʾݣÿֽڰ2seg
	for(n=0;n<(Vkl060_SEGNUM/2+1);n++)  //SEGΪҪ1ֽڻ
	{ 
		Vkl060_I2CDatByte(0x00);    // ʼʾڴ,޸. 
		if( Vkl060_I2CSlaveAck()==1 )
		{
			Vkl060_I2CStop();	
			return 1;
		}
	}
	//STOPź
	Vkl060_I2CStop(); 
  //STARTź  
	Vkl060_I2CStart();
	//SLAVEַ
	Vkl060_I2CCmdByte(Vkl060_ADDR);
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();	
		return 1;
	}
  //ʾģʽʾ
	Vkl060_I2CCmdByte(Vkl060_MODESET_1_3_ON);		//ʾ 1/3bias
//		Vkl060_I2CCmdByte(Vkl060_MODESET_1_2_ON);	//ʾ 1/2bias
	if( 1 == Vkl060_I2CSlaveAck() )
	{
		Vkl060_I2CStop();	
		return 1;
	}
	Vkl060_I2CStop();	
		
  return  0; 
}
/*******************************************************************************
* Function Name  : Lowlevel_Init
* Description    : ͨGPIO
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl060_Lowlevel_Init(void)
{
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	Vkl060_SET_SDA_DIR();
	GPIO_SetMode(Vkl060_SCL_PORT, Vkl060_SCL_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(Vkl060_SDA_PORT, Vkl060_SDA_PIN, GPIO_MODE_QUASI);
		     
	Vkl060_SCL_H();  
	Vkl060_SDA_H(); 	
}
/*******************************************************************************
* Function Name  : Init
* Description    : ʼ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl060_Init(void)
{	
	//ܽøݿͻƬӦ޸
	Vkl060_Lowlevel_Init();
	//ʼʱ
	Vkl060_InitSequence();
}
/*******************************************************************************
* Function Name  : disp_3num
* Description    : ʾ3λ
* Input          dat->3λ ʮ 
* Output         : None
* Return         : None
*******************************************************************************/
void disp_3num(unsigned int dat)
{		
	unsigned dat8;
	
	dat8=dat/100%10;	//ʾλ
	vkl060_dispram[0]&=0x7f;
	vkl060_dispram[0]|=shuzi_zimo[dat8];
	
	dat8=dat/10%10; 	//ʾʮλ
	vkl060_dispram[1]&=0x7f;
	vkl060_dispram[1]|=shuzi_zimo[dat8];
	
	dat8=dat%10;			//ʾλ
	vkl060_dispram[2]&=0x7f;
	vkl060_dispram[2]|=shuzi_zimo[dat8];
		
	if(dat<100)				//С100λʾ
	{
		vkl060_dispram[0]&=0x7f;
	}
	if(dat<10) 	//С10ʮλʾ
	{
		vkl060_dispram[1]&=0x7f;
	}
	//SEG11
//	Write1DataVkl060(11,vkl060_dispram[0]);
//	Write1DataVkl060(12,vkl060_dispram[1]);
//	Write1DataVkl060(13,vkl060_dispram[2]);
	//SEGͶ
	WritenDataVkl060(11,&vkl060_dispram[0],3);
}	
/*******************************************************************************
* Function Name  : test_Main
* Description    : 
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vkl060_Main(void)
{	
	Vkl060_Init();
	Vkl060_DisAll(0x00);
	while(1)
	{
		Vkl060_DisAll(0xff);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vkl060_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		disp_3num(123);           //ʾ123
		delay_nms(3000);					//ʱ3S
		
		Vkl060_DisAll(0x00);			//LCDȫ
		for(vkl060_segi=0;vkl060_segi<Vkl060_SEGNUM;vkl060_segi++)//seg
		{
			for(vkl060_comi=0;vkl060_comi<vkl060_maxcom;vkl060_comi++)//com
			{
				Vkl060_DisSegComOn(vkl060_segtab[vkl060_segi],vkl060_comi);	//LCD
				delay_nms(300);				//ʱ300mS
				Vkl060_DisAll(0x00);	//LCDȫ
			}
		}
		
		Vkl060_DisAll(0xff);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		for(vkl060_segi=0;vkl060_segi<Vkl060_SEGNUM;vkl060_segi++)//seg
		{
			for(vkl060_comi=0;vkl060_comi<vkl060_maxcom;vkl060_comi++)//com
			{
				Vkl060_DisSegComOff(vkl060_segtab[vkl060_segi],vkl060_comi);	//LCDر
				delay_nms(300);				//ʱ300mS
				Vkl060_DisAll(0xff);	//LCDȫ
			}
		}
		delay_nms(1000);					//ʱ1S
		
		Vkl060_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vkl060_Enter_Standby();		//͹ģʽ
		delay_nms(5000);					//ʱ5S
		
		Vkl060_Exit_Standby();		//˳͹ģʽ
	}
}
/************************END OF FILE****/
